'DIRHTML.BAS    Ray Thomas      16th February 2006

'Program to read the files listed in dir.txt and (gained by
'DIR "k:\website\free host\*.htm*" /s/b > d:\website\dir.txt) and to
'create a HTML file named files.htm which lists the files found in that file.

'*** User changeable variables ***

DIM dirFile AS STRING   'The directory file - this should be the same as that
                        'specified in htmldir.bat
DIM htmlOut AS STRING   'The HTML output file - this includes the path
DIM ignore AS STRING    'The part of the directory path to replace with
                        'either nothing ie httpPath = "" or whatever is in
                        'httpPath
DIM httpPath AS STRING  'If the absolute path is to be shown in the HTML
                        'directory then use this
                        'for example http://brisray.250free.com
                        'If a listing of just the directories and files is
                        'needed then leave this as ""

dirFile$ = "k:\website\dir.txt"
htmlOut$ = "k:\website\dir.htm"
ignore$ = "k:\website\free hosts\"
httpPath$ = "http://brisray.250free.com/"

'*** Program variables - do not change unless you know what you are doing ***

DIM inFile AS STRING    'Holds the lines from the directory file
DIM posn AS INTEGER     'Place holder for instr command

OPEN dirFile$ FOR INPUT ACCESS READ LOCK READ WRITE AS #1
OPEN htmlOut$ FOR OUTPUT ACCESS WRITE LOCK READ WRITE AS #2

'*** This part writes the HTML header

PRINT #2, "<!DOCTYPE HTML PUBLIC " + CHR$(34) + "-//W3C//DTD HTML 4.0 Transitional//EN" + CHR$(34); ""
PRINT #2, CHR$(34) + "http://www.w3.org/TR/REC-html40/loose.dtd" + CHR$(34) + ">"
PRINT #2, "<HTML>"
PRINT #2, "<HEAD>"
PRINT #2, "<meta http-equiv=" + CHR$(34) + "content-Type" + CHR$(34) + "- content=" + CHR$(34) + "text/html charset=windows-1252" + CHR$(34) + ">"
PRINT #2, "<TITLE>HTML Directory</TITLE>"
PRINT #2, "</HEAD>"
PRINT #2, ""
PRINT #2, "<BODY>"
PRINT #2, ""
PRINT #2, "<p>"

'*** This part processes the directory listing and writes the HTML links

DO
        LINE INPUT #1, inFile$

        '*** Replaces ignore$ with httpPath$

        IF INSTR(inFile$, ignore$) > 0 THEN
                inFile$ = MID$(inFile$, LEN(ignore$) + 1)
                inFile$ = httpPath$ + inFile$
        END IF

        '*** Checks for and replaces \ with /

        posn = 1
        DO UNTIL INSTR(posn, inFile$, "\") < 1
                posn = INSTR(1, inFile$, "\")
                MID$(inFile$, posn, 1) = "/"
                posn = posn + 1
        LOOP
        PRINT #2, "<a href=" + CHR$(34) + inFile$ + CHR$(34) + ">" + inFile$ + "</a><br>"
LOOP UNTIL EOF(1)

'*** This part writes the HTML footer

PRINT #2, "</p>"
PRINT #2, ""
PRINT #2, "</BODY>"
PRINT #2, "</HTML>"

CLOSE
SYSTEM

