'NumBase        Ray Thomas      March 2002

OPTION BASE 1

'*** Calculation variables ***

DIM Bases(5) AS INTEGER         'Array to hold the base numbers
DIM NumArray(5) AS STRING       'Array to hold converted numbers
DIM UserNum AS DOUBLE           'User supplied number as decimal
DIM TempNum AS DOUBLE           'Temporary number variable
DIM BaseNum AS INTEGER          'Base to do the conversion to
DIM ModNum AS INTEGER           'Remainder from the calculations
DIM StrNum AS STRING            'Used to hold a number as a string
DIM Count AS INTEGER            'Loop counter
DIM OutNum AS DOUBLE            'Output from to Decimal routine
DIM Counter AS INTEGER          'Loop Counter
DIM PosnNum AS STRING           'Character at a position inside a string
DIM ConvNum AS INTEGER          'Numeric of PosNum

'*** Menu variables ***

DIM MenuItem(6) AS STRING * 25  'Define the menu item array
DIM ChooseItem AS INTEGER       'Currently chosen menu item
DIM XMenuposn AS INTEGER        'Controls the menu item X positions
DIM YMenuPosn AS INTEGER        'Controls the menu item Y positions
DIM EndMenu AS INTEGER          'F, Enter or Alt keys pressed

DATA 10,2,8,16
DATA F1 - Decimal, F2 - Binary, F3 - Octal
DATA F4 - Hexadecimal, F5 - Choose a base, F6 - Quit the program

ChooseItem = 1          'Starting point of highlighted menu item
XMenuposn = 20          'X starting point of menu
YMenuPosn = 10          'Y starting point of menu

'*** Fill the bases array ***

FOR Count = 1 TO 4
        READ Bases(Count)
NEXT Count

'*** Fill the MenuItme Array ***

FOR Count = 1 TO UBOUND(MenuItem$)
        READ MenuItem(Count)
NEXT Count

CLS

PRINT
PRINT "   A program to find the binary, octal and hexadecimal"
PRINT "   representations of a decimal number."
PRINT
PRINT "   Use the Enter key to choose the highlighted menu item or"
PRINT "   Press the F number key associated with the menu item or"
PRINT "   Press the Alt key and the capitalised letter of the menu item"
GOSUB DrawMenu

'*** get cursor key movements and redraw menu ***
DO
        DO
                Cmmnd$ = (INKEY$)
                IF LEN(Cmmnd$) = 2 THEN Cmmnd$ = RIGHT$(Cmmnd$, 1)
                               
                IF Cmmnd$ = "8" OR Cmmnd$ = CHR$(72) THEN GOSUB MoveUp
                IF Cmmnd$ = "2" OR Cmmnd$ = CHR$(80) THEN GOSUB MoveDown
                IF Cmmnd$ = "7" OR Cmmnd$ = CHR$(71) THEN ChooseItem = 1
                IF Cmmnd$ = "1" OR Cmmnd$ = CHR$(79) THEN ChooseItem = UBOUND(MenuItem)
                IF Cmmnd$ = CHR$(13) THEN EndMenu = 1
       
                IF Cmmnd$ = CHR$(59) OR Cmmnd$ = CHR$(32) THEN
                        ChooseItem = 1
                        EndMenu = 1
                END IF
                IF Cmmnd$ = CHR$(60) OR Cmmnd$ = CHR$(48) THEN
                        ChooseItem = 2
                        EndMenu = 1
                END IF
                IF Cmmnd$ = CHR$(61) OR Cmmnd$ = CHR$(24) THEN
                        ChooseItem = 3
                        EndMenu = 1
                END IF
                IF Cmmnd$ = CHR$(62) OR Cmmnd$ = CHR$(35) THEN
                        ChooseItem = 4
                        EndMenu = 1
                END IF
                IF Cmmnd$ = CHR$(63) OR Cmmnd$ = CHR$(46) THEN
                        ChooseItem = 5
                        EndMenu = 1
                END IF
                IF Cmmnd$ = CHR$(64) OR Cmmnd$ = CHR$(16) THEN
                        ChooseItem = 6
                        EndMenu = 1
                END IF

                GOSUB DrawMenu
       
        LOOP UNTIL EndMenu = 1

        '*** Reset variables, there are problems if this is not done ***
       
        FOR Count = 1 TO 5
                NumArray$ = ""
        NEXT Count
        TempNum = 0
        StrNum$ = ""
        BaseNum = 0
        ModNum = 0
        UserNum = 0
        EndMenu = 0
        OutNum = 0
        ConvNum = 0

        IF ChooseItem = 6 THEN EXIT DO
        COLOR 7, 0
        IF ChooseItem = 5 THEN
                GOSUB GetBase
        ELSE
                GOSUB GetNumber
                IF ChooseItem <> 1 THEN GOSUB ToDecimal
                GOSUB ToBase
                GOSUB Results
        END IF


LOOP UNTIL ChooseItem = 6

END

DrawMenu:
'*** Draw the menu ***

LOCATE YMenuPosn, XMenuposn

FOR Count = 1 TO UBOUND(MenuItem$)
        IF Count = ChooseItem THEN COLOR 4, 2 ELSE COLOR 2, 4
        LOCATE CSRLIN, XMenuposn
        PRINT MenuItem$(Count)
NEXT Count
RETURN

MoveUp:
IF ChooseItem = 1 THEN
        ChooseItem = UBOUND(MenuItem$)
ELSE
        ChooseItem = ChooseItem - 1
END IF

RETURN

MoveDown:
IF ChooseItem = UBOUND(MenuItem$) THEN
        ChooseItem = 1
ELSE
        ChooseItem = ChooseItem + 1
END IF

RETURN

ToBase:

'*** Do Decimal to other bases ***

'*** The code below will work for ANY base ***
'*** It needs the number as a numeric to work ***

FOR Count = 2 TO UBOUND(Bases)

        IF Bases(Count) = 0 THEN EXIT FOR

        TempNum = VAL(NumArray(1))
        BaseNum = Bases(Count)
        StrNum$ = ""

        '*** Take the number, and keep dividing by the base number ***
        '*** Add the results to the output string ***

        DO
                ModNum = TempNum MOD BaseNum
                TempNum = FIX(TempNum / BaseNum)
       
                IF ModNum > 9 THEN
                        StrNum$ = CHR$(ModNum + 55) + StrNum
                ELSE
                        StrNum$ = STR$(ModNum) + StrNum$
                END IF

                StrNum$ = LTRIM$(RTRIM$(StrNum$))

                IF TempNum < BaseNum THEN
               
                        IF TempNum > 9 THEN
                                StrNum$ = CHR$(TempNum + 55) + StrNum$
                        ELSE
                                StrNum$ = STR$(TempNum) + StrNum$
                        END IF
                END IF
       
                StrNum$ = LTRIM$(RTRIM$(StrNum$))

        LOOP UNTIL TempNum < BaseNum

        IF LEFT$(StrNum$, 1) = "0" THEN StrNum$ = MID$(StrNum$, 2)
        NumArray(Count) = StrNum$

NEXT Count
RETURN

ToDecimal:

'*** Do Base to Decimal ***

'*** The code below will work for ANY base ***
'*** It needs the number as a string to work ***

BaseNum = Bases(ChooseItem)
StrNum$ = NumArray(ChooseItem)

FOR Count = 1 TO LEN(StrNum$)

        '*** Convert the current character to a number ***
       
        PosnNum$ = MID$(StrNum$, Count, 1)
       
        IF ASC(PosnNum$) > 59 THEN
                ConvNum = ASC(PosnNum$) - 55
        ELSE
                ConvNum = VAL(PosnNum)
        END IF

        '*** Get the value of that base at that position ***
        '*** the series goes ... n^5, n^4, n^3, n^2, n, 1 ***

        IF Count = LEN(StrNum$) THEN

                TempNum = 1
        ELSE
                TempNum = BaseNum
       
                FOR Counter = 1 TO (LEN(StrNum$) - Count - 1)
                       
                        TempNum = TempNum * BaseNum
               
                NEXT Counter
                
        END IF

        OutNum = OutNum + (TempNum * ConvNum)

NEXT Count

NumArray$(1) = LTRIM$(STR$(OutNum))

RETURN

GetBase:
        LOCATE 17, 3
        PRINT SPACE$(60)
        LOCATE 17, 3
        INPUT "What number base do you want to use ", UserNum
        Bases(5) = UserNum
        MenuItem$(5) = "F5 - Chosen base" + STR$(UserNum)
        LOCATE 17, 3
        PRINT SPACE$(60)
RETURN

GetNumber:
        LOCATE 17, 3
        PRINT SPACE$(60)
        LOCATE 17, 3
        INPUT "What number do you want to convert ", UserNum
        NumArray(ChooseItem) = STR$(UserNum)
        LOCATE 17, 3
        PRINT SPACE$(60)
RETURN

Results:

LOCATE 17, 3
PRINT "Decimal"; TAB(20); NumArray$(1)
LOCATE 18, 3
PRINT "Binary"; TAB(20); NumArray$(2)
LOCATE 19, 3
PRINT "Octal"; TAB(20); NumArray$(3)
LOCATE 20, 3
PRINT "Hexadecimal"; TAB(20); NumArray$(4)
IF NumArray$(5) <> "" THEN
        LOCATE 21, 3
        PRINT "Your base"; Bases(5); TAB(20); NumArray$(5)
END IF

'*** Check the results ***
LOCATE 19, 40
PRINT "OCT$ "; OCT$(VAL(NumArray$(1)))
LOCATE 20, 40
PRINT "HEX$ "; HEX$(VAL(NumArray$(1)))

LOCATE 23, 3
PRINT "Press any key to continue ..."
DO
LOOP UNTIL INKEY$ <> ""
FOR Count = 17 TO 23
        LOCATE Count, 3
        PRINT SPACE$(60)
NEXT Count

RETURN


