' ranquest.bas  Ray Thomas      March 2002

'A random question generator

OPTION BASE 1

'*** Program variables ***

DIM QuestArray(5) AS STRING     'Question array
DIM AnsArray(5) AS STRING       'Answer array
DIM Count AS INTEGER            'Loop counter
DIM Num AS INTEGER              'General numeric
DIM NumAry AS INTEGER           'Number of elements in the arrays
DIM UserAns AS STRING           'User reply to questions
DIM Qasked AS INTEGER           'Number of questions asked
DIM QCrrct AS SINGLE            'Number of questions answered correctly
DIM QLeft AS INTEGER            'Questions left to ask

'*** Question and answer data ***

DATA "When did Indiana become a state","1816"
DATA "Who is considered the father of Communism","Karl Marx"
DATA "In what year did the Titanic sink","1912"
DATA "To what number base is hexadecimal","16"
DATA "From what flower was digitalis derived","Foxglove"

'*** Initialise variables ***

RANDOMIZE TIMER
NumAry = UBOUND(AnsArray$)
QLeft = NumAry

'*** Fill the question and answer arrays ***

FOR Count = 1 TO UBOUND(QuestArray$)
        READ QuestArray$(Count)
        READ AnsArray$(Count)
NEXT Count

DO
        '*** Prepare the screen ***
       
        UserAns$ = ""
        CLS
        LOCATE 2, 2
        PRINT "Please answer the questions, or Q to quit the program"
        PRINT

        '*** Get and ask the question ***
        '*** QLeft ensures the same question isn't asked twice ***

        Num = INT(RND * QLeft) + 1
        LOCATE 4, 2
        PRINT QuestArray$(Num) + "?"
        Qasked = Qasked + 1

        '*** Get and compare the answer ***

        LOCATE 6, 2
        LINE INPUT ; UserAns$
        LOCATE 8, 2

        IF UCASE$(UserAns$) = "Q" THEN EXIT DO

        IF UCASE$(AnsArray$(Num)) = UCASE$(UserAns$) THEN
               
                PRINT "*** Correct *** WELL DONE ***"
                QCrrct = QCrrct + 1
        ELSE

                IF INSTR(UCASE$(AnsArray$(Num)), UCASE$(UserAns$)) > 0 THEN
        
                        PRINT "*** Sort of Correct *** Half a mark ***"
                        QCrrct = QCrrct + .5
                ELSE
                        PRINT "*** Oops, incorrect. Do you want to see the correct answer?"
               
                        DO
                                UserAns$ = UCASE$(INKEY$)
                        LOOP UNTIL UserAns$ = "Y" OR UserAns$ = "N"

                END IF
        END IF
               
        '*** Confirm and print the correct answer ***
        '*** Only do this if the answer is correct ***
        '*** or the user wants to see the answer ***
       
        IF UserAns$ <> "N" THEN
                LOCATE 10, 2
                PRINT "The answer to "; QuestArray$(Num); " is :-"
                LOCATE 12, 2
                PRINT AnsArray$(Num)
               
                '*** Ensure the same question isn't asked twice ***
                '*** by moving all the elements in the arrays up by 1 ***
                '*** and decreasing QLeft, which limits the RND ***
               
                QLeft = QLeft - 1
                FOR Count = Num TO NumAry - 1
                        QuestArray$(Count) = QuestArray$(Count + 1)
                        AnsArray$(Count) = AnsArray$(Count + 1)
                NEXT Count
        END IF

        LOCATE 15, 2
        PRINT "Questions left ="; QLeft
        LOCATE 17, 2
        PRINT "Press any key to continue ..."
        DO
        LOOP UNTIL INKEY$ <> ""

LOOP UNTIL QLeft = 0

CLS
LOCATE 3, 3
PRINT "*** Thanks for playing ***"
LOCATE
LOCATE 5, 3
PRINT "Out of"; Qasked; "questions, you got"; QCrrct; "correct"
END




