'WEBFILE1.BAS   Ray Thomas      July 1999

'A program to display the records WEB1.DAT, opened as a RANDOM file

DIM Path AS STRING      'Holds YOUR path to the file being used
DIM InCount AS LONG     'Counter for number of records input
DIM FileNo AS INTEGER   'Gets the next free file stream
DIM InRecord AS STRING  'Variable to keep each record
DIM NoRecs AS LONG      'Gets the number of records in the file
DIM FilePath AS STRING  'File path + file name

Path$ = "E:\RAY\WEBSITE\DEVT\"    'Replace this with the path to where the
                                'you saved the data files
FileNo = FREEFILE               'Determines the next free file stream
RecLen = 114                    'The record length of the records

'**************************************************************************
'This piece of code gets each record in turn and displays the whole record

OPEN Path$ + "WEB1.DAT" FOR RANDOM ACCESS READ LOCK READ WRITE AS FileNo LEN = RecLen
FIELD FileNo, 114 AS InRecord$

NoRecs = LOF(FileNo) / RecLen
FOR InCount = 1 TO NoRecs
        GET FileNo, InCount     'Read each record in turn to InRecord$
        PRINT InRecord$         'Any data manipulation can be carried out here
NEXT InCount
CLOSE FileNo                    'Closes the opened file stream

PRINT
PRINT "Press an key to continue . . ."
DO
LOOP UNTIL INKEY$ <> ""

'**************************************************************************
'==========================================================================
'This piece of code demonstrates we can get any record we want and using the
'FIELD instruction get just the bit of data we want.

OPEN Path$ + "WEB1.DAT" FOR RANDOM ACCESS READ LOCK READ WRITE AS FileNo LEN = RecLen
FIELD FileNo, 19 AS Waste1$, 30 AS InRecord$, 65 AS Waste2$

CLS
PRINT
GET FileNo, 2           'Get record number 2
PRINT InRecord$
GET FileNo, 5           'Get record number 5
PRINT InRecord$
GET FileNo, 7           'Get record number 7
PRINT InRecord$
CLOSE FileNo
PRINT
PRINT "Press an key to continue . . ."
DO
LOOP UNTIL INKEY$ <> ""

'==========================================================================
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'The next piece of code demostrates how to read a RANDOM fileusing the data type.

'REMEMBER - If you change the record length of 1 record then you must change
'them all. If you don't then you no longer have a random data file but a load
'of junk!!!!

'The very useful FIELD statement is no longer available if you use Visual
'BASIC, the TYPE statement is used instead. QBasic offered both types of
'record input

TYPE RecStruct
        SeqNo AS STRING * 4
        Title AS STRING * 10
        Initial AS STRING * 5
        Surname AS STRING * 10
        Add1 AS STRING * 20
        Add2 AS STRING * 15
        Add3 AS STRING * 20
        Postcode AS STRING * 10
        Number AS LONG
        Filler AS STRING * 4
        Job AS STRING * 11
END TYPE
DIM Record AS RecStruct

CLS
OPEN Path$ + "WEB1.DAT" FOR RANDOM ACCESS READ LOCK READ WRITE AS FileNo LEN = RecLen
FOR InCount = 1 TO NoRecs
        GET FileNo, InCount, Record
        PRINT Record.SeqNo; Record.Surname; Record.Add1
NEXT InCount
CLOSE FileNo
END


















